# Подключение внешних проектов
include(ExternalProject)

if(PreprocThirdparty_FIND_COMPONENTS STREQUAL "headers")
  ExternalProject_Add(
    libpreproc
    DEPENDS libpreprocmath
    SOURCE_DIR ${CMAKE_SOURCE_DIR}/thirdparty/libpreproc
    INSTALL_DIR ${CMAKE_BINARY_DIR}
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND
      ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}"
      -DLIBPREPROCMATH_PREFIX=${CMAKE_BINARY_DIR}
      -DCMLIB_MAIN_DIR=${CMLIB_MAIN_DIR} ${CMLIB_EXT_PROJ_DEFAULT_ARGS}
      <SOURCE_DIR>
    BUILD_COMMAND true
    INSTALL_COMMAND make preproc-install-headers)
else()
  ExternalProject_Add(
    libpreproc
    DEPENDS libpreprocmath
    SOURCE_DIR ${CMAKE_SOURCE_DIR}/thirdparty/libpreproc
    INSTALL_DIR ${CMAKE_BINARY_DIR}
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND
      ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}"
      -DLIBPREPROCMATH_PREFIX=${CMAKE_BINARY_DIR}
      -DCMLIB_MAIN_DIR=${CMLIB_MAIN_DIR} ${CMLIB_EXT_PROJ_DEFAULT_ARGS}
      <SOURCE_DIR>)
endif()

set(LIBPREPROC_IS_EXTERNAL_PROJECT ON CACHE BOOL "" FORCE)

set(LIBPREPROC_PREFIX
    ${CMAKE_BINARY_DIR}
    CACHE FILEPATH "" FORCE)
set(LIBPREPROC_INCLUDE_DIRS
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}
    CACHE PATH "" FORCE)
set(LIBPREPROC_LIBRARY_DIR
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}
    CACHE PATH "" FORCE)
set(LIBPREPROC_LIBRARY
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/libpreproc.a
    CACHE FILEPATH "" FORCE)
